# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
"""
__revision__ = "V2.2"
#
#
import os
#
########################## Debut de la fonction ##################################
#
def exec_commande (arguments, verbose) :
#
  """
   Arguments :
     1. Nom de la commande a executer
     2. Mode verbeux ou non

   Au retour on a 0 si tout va bien, le code systeme sinon
  """
#gn  print "Arguments a l'entree de", __name__, ":", arguments
#
  message_erreur = ""
#
# 1. Execution
#
  commande = arguments[0:]
  erreur = os.system (commande)
#
# 2. La fin
#
  if erreur :
#
    err = [0]
    try :
      message_erreur += os.strerror(erreur)
    except os.error, err :
      pass
#
    if verbose :
#
      message_erreur += "\nDans le repertoire : " + os.getcwd() + "\n"
#gn      print "Contenu du repertoire :", os.listdir(os.getcwd())
      message_erreur += "Erreur a l'execution de : " + commande + "\n"
      message_erreur += "Code de retour : " + str(erreur) + "\n"
#
    message_erreur += "\n"
#
  return erreur, message_erreur
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
def verif (texte, reference, calcul):
#
  """
   Arguments :
     1. Texte a afficher
     2. Resultat de reference
     3. Resultat a comparer
  """
###  print "Reference :", reference
###  print "Calcul    :", calcul, "\n"
  bilan = "OK"
  if reference != calcul :
    type_objet = type(calcul)
#    print type_objet
    dico = { }
    tupl = ( )
    if type_objet == type(dico) :
      for cle in reference.keys():
        if not calcul.has_key(cle):
          print cle, "est present dans la reference, mais pas dans le calcul."
          bilan = "ECHEC"
        else :
          if reference[cle] != calcul[cle] :
            print "Pour ", cle, " : Reference = ", reference[cle]
            print "Pour ", cle, " : Calcul    = ", calcul[cle]
            bilan = "ECHEC"
      for cle in calcul.keys():
        if not reference.has_key(cle):
          print cle, "est present dans le calcul, mais pas dans la reference."
          bilan = "ECHEC"
    elif type_objet == type(tupl) :
      if len(reference) != len(calcul) :
        print "Longueurs differentes :"
        print "Reference :", reference
        print "Calcul    :", calcul, "\n"
        bilan = "ECHEC"
      else :
        for num in range(len(reference)) :
          if reference[num] != calcul[num] :
            print "Pour ", num, " :"
            if type(reference[num]) == type(dico) :
              for cle in reference[num].keys():
                if not calcul[num].has_key(cle):
                  print cle, "est present dans la reference, mais pas dans le calcul."
                  bilan = "ECHEC"
                else :
                  if reference[num][cle] != calcul[num][cle] :
                    print "Pour ", cle, " : Reference = ", reference[num][cle]
                    print "Pour ", cle, " : Calcul    = ", calcul[num][cle]
                    bilan = "ECHEC"
              for cle in calcul[num].keys():
                if not reference[num].has_key(cle):
                  print cle, "est present dans le calcul, mais pas dans la reference."
                  bilan = "ECHEC"
            else :
              print ". Reference = ", reference[num]
              print ". Calcul    = ", calcul[num]
              bilan = "ECHEC"
    else :
      print "Reference :", reference
      print "Calcul    :", calcul, "\n"
      bilan = "ECHEC"
#
  print texte, " : ", bilan, "\n"
#
##########################  Fin de la fonction  ##################################
########################## Debut de la fonction ##################################
#
def int_to_str2 (entier) :
#
  """
  transforme un entier positif en une chaine d'au moins deux caracteres
  """
#
#  print "\nArguments a l'entree de", __name__, ":", entier
#
  if type(entier) == type(0) :
    la_chaine = '%02d' % entier
  else :
    la_chaine = None
#
  return la_chaine
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  l1 = "ls -ltr $HOME"
  l1_refe = 0
  l1_calc = exec_commande(l1)
  verif ("Test sur exec_commande avec "+l1, l1_refe, l1_calc)
#
